unit BasicDemo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, SecureCode;

type
  TMainForm = class(TForm)
    memoLog: TMemo;
    btStart: TButton;
    Label1: TLabel;
    Button1: TButton;
    cbFileCheck: TCheckBox;
    procedure btStartClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
    SecureCode : TSecureCode;
    procedure FileModified;
  public
    { Dclarations publiques }
    procedure SecureIdvBlock;
    procedure SecureBasic;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)

procedure TMainForm.btStartClick(Sender: TObject);
begin
  SecureBasic;
end;

(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)

procedure TMainForm.FileModified;
begin
  ShowMessage('This executable file has been modified!, please restore from original setup, thank you');
  memoLog.Lines.Add('Executable file corrupted, please restore from original...');
  // here you can choose to close application or whateven you want...
end;

(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)


(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)

procedure TMainForm.SecureIdvBlock;
label
  scBlockStart; // Require to secure block individually
var
  scBlockID : Cardinal; // Require to secure block individually
  i : Cardinal;
begin
  SecureCode := TSecureCode.Create;
  try
    // Check if anyone try to debug or trace
    if not SecureCode.IsDebugging then
    begin
      if cbFileCheck.Checked then
        SecureCode.FileModified := FileModified;

      SecureCode.Key := 'demo';
      SecureCode.Init;
      {$I SC_INIT.INC} // Require to secure block individually
      if SecureCode.Decrypt(scBlockID) then
      begin
      {$I SC_START_IDV.INC}
        for i := 1 to 10 do
          memoLog.Lines.Add('This block is protected individually!');
      {$I SC_END.INC}
      end;
      SecureCode.SecureBlock(scBlockID); // Resecure blocks in memory after use
    end
    else
      memoLog.Lines.Add('Debugger detected!');
  finally
    SecureCode.Free;
  end;
end;

(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)

procedure TMainForm.SecureBasic;
var
  i : Cardinal;
begin
  SecureCode := TSecureCode.Create;
  try
    // Check if anyone try to debug or trace
    if not SecureCode.IsDebugging then
    begin
      if cbFileCheck.Checked then
        SecureCode.FileModified := FileModified;

      SecureCode.Key := 'demo';
      SecureCode.Init;
      if SecureCode.Decrypt then
      begin
      {$I SC_START.INC}
        for i := 1 to 10 do
          memoLog.Lines.Add('Hello World!');
      {$I SC_END.INC}
      end;
    end
    else
      memoLog.Lines.Add('Debugger detected!');
  finally
    SecureCode.Free;
  end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  SecureIdvBlock;
end;

end.
